# Treebar Maps
This is the repository for the code related to the project Treebar Maps.
The Treebar Map framework has been presented in the paper 

Giuseppe Di Battista, Fabrizio Grosso, Silvia Montorselli, Maurizio Patrignani. **Treebar Maps: Schematic Representation of Networks at Scale**. Proceedings of IEEE Pacific Visualization Symposium. 2024.

In this repository there are two directories.

The **public** directory contains the files and examples used by the demonstrative website available at https://treebarmaps.ing.uniroma3.it/
The **src** directory contains all the code used to produce Treebar Maps 


## Generate a Treebar Map
To use the code in the **src** directory to generate your own Treebar Map, first of all you must download the directory to your computer.

The input graph must be provided in the form of an edge list. The input file should contain on each row two natural numbers, the vertices id, separated by a tabular space.

A pre-requisite for the computation of a Core-Connectivity Tree is that the input graph is undirected and simple.
You can use the command **order_pairs.sh** on a unix machine to clean your input. For Windows users, it is possible to run the command on VLS.

`.\order_pair <input-file>`

Then, to compute the Core-Connectivity Tree, you must compile the file **core-connectivity_tree.c**

`gcc -o core-connectivity_tree -O3 -march=native core-connectivity_tree.c`

This code, can be executed to obtain a json file representing the Core-Connectivity Tree that will be saved in the same path as the input

`core-connectivity_tree <input-file>`

The visualization can be performed launching a server, like python servers

`python -m http.server`

and then use the textbox generated by **TreebarMaps.js** to load the output file of the previous step.
